Package ru.bitel.oss.systems.inventory.product.common.service

# Interface ProductService

public interface ProductService

- ## Method Summary

  Modifier and Type
  Method
  Description
  `List<String[]>`
  `getIncompatibleItems(int moduleId)`
  `void`
  `productDelete(int contractId, int productId)`
  `Product`
  `productGet(int contractId, int productId)`
  `List<Product>`
  `productList(int moduleId, int contractId, int accountId, boolean kernel, Date timeFrom, Date timeTo, Date intersectTimeFrom, Date intersectTimeTo, boolean nonActive)`
  Deprecated.
  `List<Product>`
  `productList(int moduleId, int contractId, int accountId, boolean kernel, Date timeFrom, Date timeTo, Date intersectTimeFrom, Date intersectTimeTo, boolean nonActive, boolean needProductPeriods)`
  `void`
  `productPeriodDelete(int contractId, int productPeriodId)`
  `List<ProductPeriod>`
  `productPeriodList(int contractId, int productId)`
  `int`
  `productPeriodUpdate(int contractId, ProductPeriod productPeriod)`
  `void`
  `productSpecActivationModeDelete(int id)`
  `ProductSpecActivationMode`
  `productSpecActivationModeGet(int id)`
  `List<ProductSpecActivationMode>`
  `productSpecActivationModeList()`
  `int`
  `productSpecActivationModeUpdate(ProductSpecActivationMode productSpecActivationMode)`
  `void`
  `productSpecDelete(int id)`
  `ProductSpec`
  `productSpecGet(int id)`
  `ProductSpec`
  `productSpecGetByIdentifier(String identifier)`
  `List<ProductSpec>`
  `productSpecList(Integer moduleId, Date dateFrom, Date dateTo, String title, List<FilterEntityAttr> entityFilter)`
  `void`
  `productSpecMove(int id, Set<Integer> ids)`
  `ProductSpec`
  `productSpecRoot(Integer moduleId, Date dateFrom, Date dateTo, String title, List<FilterEntityAttr> entityFilter)`
  `org.json.JSONObject`
  `productSpecTree(int moduleId)`
  `int`
  `productSpecUpdate(ProductSpec productSpec)`
  `void`
  `productTreeReorder(int srcProductId, int parentProductId, int childIndex)`
  `int`
  `productUpdate(Product product)`
  `List<ProductSpecServiceLink>`
  `serviceLinkList(int productSpecId, Date date)`
  `void`
  `serviceLinkUpdate(int productSpecId, List<ProductSpecServiceLink> linkList)`

- ## Method Details

  - ### productSpecGet

    ProductSpec productSpecGet(int id) throws Exception
    Throws:
      `Exception`

  - ### productSpecGetByIdentifier

    ProductSpec productSpecGetByIdentifier(String identifier) throws Exception
    Throws:
      `Exception`

  - ### productSpecList

    List<ProductSpec> productSpecList(Integer moduleId, Date dateFrom, Date dateTo, String title, List<FilterEntityAttr> entityFilter) throws Exception
    Throws:
      `Exception`

  - ### productSpecRoot

    ProductSpec productSpecRoot(Integer moduleId, Date dateFrom, Date dateTo, String title, List<FilterEntityAttr> entityFilter) throws Exception
    Throws:
      `Exception`

  - ### productSpecTree

    org.json.JSONObject productSpecTree(int moduleId) throws Exception
    Throws:
      `Exception`

  - ### productSpecUpdate

    int productSpecUpdate(ProductSpec productSpec) throws Exception
    Throws:
      `Exception`

  - ### productSpecDelete

    void productSpecDelete(int id) throws Exception
    Throws:
      `Exception`

  - ### productSpecActivationModeList

    List<ProductSpecActivationMode> productSpecActivationModeList() throws Exception
    Throws:
      `Exception`

  - ### productSpecActivationModeGet

    ProductSpecActivationMode productSpecActivationModeGet(int id) throws Exception
    Throws:
      `Exception`

  - ### productSpecActivationModeUpdate

    int productSpecActivationModeUpdate(ProductSpecActivationMode productSpecActivationMode) throws Exception
    Throws:
      `Exception`

  - ### productSpecActivationModeDelete

    void productSpecActivationModeDelete(int id) throws Exception
    Throws:
      `Exception`

  - ### productSpecMove

    void productSpecMove(int id, Set<Integer> ids) throws Exception
    Throws:
      `Exception`

  - ### serviceLinkList

    List<ProductSpecServiceLink> serviceLinkList(int productSpecId, Date date) throws Exception
    Throws:
      `Exception`

  - ### serviceLinkUpdate

    void serviceLinkUpdate(int productSpecId, List<ProductSpecServiceLink> linkList) throws Exception
    Throws:
      `Exception`

  - ### productList

    @RequestWrapper(className="ru.bitel.oss.systems.inventory.product.common.jaxws.ProductListOldRequest") @ResponseWrapper(className="ru.bitel.oss.systems.inventory.product.common.jaxws.ProductListOldResponse") @Deprecated List<Product> productList(int moduleId, int contractId, int accountId, boolean kernel, Date timeFrom, Date timeTo, Date intersectTimeFrom, Date intersectTimeTo, boolean nonActive) throws Exception
    Deprecated.
    Throws:
      `Exception`

  - ### productList

    List<Product> productList(int moduleId, int contractId, int accountId, boolean kernel, Date timeFrom, Date timeTo, Date intersectTimeFrom, Date intersectTimeTo, boolean nonActive, boolean needProductPeriods) throws Exception
    Parameters:
      `moduleId` - -1 или 0 (ядро) или ID модуля
      `contractId` - ID договора (>0)
      `accountId` - -1 или ID аккаунта
      `kernel` - добавить продукты ядра ()
      `timeFrom` -
      `timeTo` -
      `intersectTimeFrom` -
      `intersectTimeTo` -
      `nonActive` - включать ли неактивные (timeTo<timeFrom)
      `needProductPeriods` - проставить ли subscriptionTimeFrom/subscriptionTimeTo
    Returns:
    Throws:
      `BGException`
      `Exception`

  - ### productUpdate

    int productUpdate(Product product) throws Exception
    Throws:
      `Exception`

  - ### productGet

    Product productGet(int contractId, int productId) throws Exception
    Throws:
      `Exception`

  - ### productDelete

    void productDelete(int contractId, int productId) throws Exception
    Throws:
      `Exception`

  - ### productPeriodUpdate

    int productPeriodUpdate(int contractId, ProductPeriod productPeriod) throws Exception
    Throws:
      `Exception`

  - ### productPeriodList

    List<ProductPeriod> productPeriodList(int contractId, int productId) throws Exception
    Throws:
      `Exception`

  - ### productPeriodDelete

    void productPeriodDelete(int contractId, int productPeriodId) throws Exception
    Throws:
      `Exception`

  - ### getIncompatibleItems

    List<String[]> getIncompatibleItems(int moduleId) throws Exception
    Throws:
      `Exception`

  - ### productTreeReorder

    void productTreeReorder(int srcProductId, int parentProductId, int childIndex) throws Exception
    Throws:
      `Exception`